"use strict";

const e = React.createElement;

// TODO: Move as much of this as possible into Markdown or something to be rendered.
// Or just a separate HTML page? Or React file? Idk.
class Introduction extends React.Component {
  constructor(props) {
    super(props);
  }

  render() {
    return (
      <div id="prompt">
        <h2>What is this? + Disclaimer</h2>
        <p>
          This is a little app I made to help take you through the TEAM
          self-therapy process. This is completely unofficial and not affiliated
          with David Burns or TEAM in any way! I recommend reading through the{" "}
          <a href="https://feelinggood.com/books/">Feeling Great</a> book to
          better understand how to do self-therapy.
        </p>
        <p>
          It's always best to talk to a licensed therapist or a doctor about
          your issues, especially if you're stuck on them and don't know how to
          get better. However, if you don't want to or are unable to access
          those resources for any reason, I hope that some of the information
          here can be helpful to you. I'm not a doctor, therapist, or licensed
          professional of any kind, so please don't take any of this as medical
          advice.
        </p>
        <p>
          <span style={{ color: "red", fontWeight: "bold" }}>
            This tool is not finished!
          </span>{" "}
          Right now, I'm posting it to get some early feedback on what using it
          is like. There are still some important features missing and it may be
          clunky or broken in places.
        </p>
        <h2>How it works</h2>
        <p>
          The app begins by asking you to describe a specific situation where
          you had a problem you want to work through in therapy. Then it will
          ask about your feelings and thoughts in that situation.
        </p>
        <p>
          Unlike some other forms of CBT, TEAM has a step where you try to look
          for the positive sides of those thoughts and feelings. Then, it asks
          you how much you want to keep the feelings. It's not automatically
          assumed that just because a thought is negative, it's wrong. Instead,
          you're in charge of how negative or positive you want to be.
        </p>
        <h2>More resources and information about TEAM-CBT</h2>
        <p>
          Here are some particular podcast episodes that I listened to and found
          helpful in understanding the TEAM-CBT process:
        </p>
        <ul>
          <li>
            <a href="https://feelinggood.com/2019/09/23/159-live-therapy-with-marilyn-what-if-i-die-without-having-lived-a-meaningful-life/">
              Live Therapy with Marilyn: "What if I die without having lived a
              meaningful life?"
            </a>
          </li>
          <li>
            Mega-session with Lee, broken out into three podcast episodes:
            <ul>
              <li>
                <a href="https://feelinggood.com/2018/07/09/096-live-session-with-lee-why-is-my-wife-trying-to-control-me/">
                  Live Session with Lee: “Why is my wife trying to control me?”
                </a>
              </li>
              <li>
                <a href="https://feelinggood.com/2018/07/16/097-live-session-with-lee-the-death-of-the-ego/">
                  Live Session with Lee: The Death of the Ego
                </a>
              </li>
              <li>
                <a href="https://feelinggood.com/2018/07/23/098-live-session-with-lee-part-3-the-rebirth/">
                  Live Session with Lee, Part 3: The Rebirth
                </a>
              </li>
            </ul>
          </li>
          <li>
            A series of episodes where they break down the entire process at
            each step:
            <ul>
              <li>
                <a href="https://feelinggood.com/2017/03/27/029-live-session-mark-introduction-testing-phase-part-1/">
                  Live Session (Mark) — Introduction & Testing Phase (Part 1)
                </a>
              </li>
              <li>
                <a href="https://feelinggood.com/2017/04/03/030-live-session-mark-empathy-phase-part-2/">
                  Live Session (Mark) — Empathy Phase (Part 2)
                </a>
              </li>
              <li>
                <a href="https://feelinggood.com/2017/04/10/031-live-session-mark-agenda-setting-phase-part-3/">
                  Live Session (Mark) — Agenda Setting Phase (Part 3)
                </a>
              </li>
              <li>
                <a href="https://feelinggood.com/2017/04/11/032-live-session-mark-agenda-setting-phase-part-4/">
                  Live Session (Mark) — Agenda Setting Phase (Part 4)
                </a>
              </li>
              <li>
                <a href="https://feelinggood.com/2017/04/17/033-live-session-mark-methods-phase-part-5/">
                  Live Session (Mark) — Methods Phase (Part 5)
                </a>
              </li>
              <li>
                <a href="https://feelinggood.com/2017/04/24/034-live-session-mark-methods-phase-contd-part-6/">
                  Live Session (Mark) — Methods Phase, cont’d. (Part 6)
                </a>
              </li>
              <li>
                <a href="https://feelinggood.com/2017/05/01/035-live-session-mark-final-testing-wrap-up-part-7/">
                  Live Session (Mark) — Final Testing, Wrap Up (Part 7)
                </a>
              </li>
            </ul>
          </li>
        </ul>
        <p>
          Personally, I would recommend just about all of the "live therapy"
          format episodes-- it's very helpful to listen to and get a better
          sense of the process.
        </p>
        <p>
          And here's a LessWrong post about the Feeling Good podcast with more
          episode links and information:{" "}
          <a href="https://www.lesswrong.com/posts/BLPjvGJHYkcM8Yzxy/team-a-dramatically-improved-form-of-therapy">
            TEAM: a dramatically improved form of therapy
          </a>
          .
        </p>
        <h2>Privacy</h2>
        <p>
          None of your data is collected or sent anywhere. It's stored on your
          own computer, and it stays put between visits to the page. If you're
          paranoid, you can use the app offline by turning off your WiFi.
        </p>
      </div>
    );
  }
}

class Moment extends React.Component {
  constructor(props) {
    super(props);
    this.textChanged = this.textChanged.bind(this);
    this.state = { instance: "" };
    if (!!localStorage["instance"]) {
      this.state.instance = localStorage["instance"];
    }
  }

  componentDidUpdate() {
    localStorage["instance"] = this.state.instance;
  }

  textChanged(event) {
    this.setState({ instance: event.target.value });
  }

  render() {
    return (
      <div>
        <p>
          First we need to identify the problem that you want to work on.
          Perhaps it's depression or anxiety, or problems with a relationship,
          or an issue with someone at work. Anything that you might talk through
          with a therapist or try to work through in a journal is fair game to
          start out with.
        </p>
        <p>
          Then we need to zoom in and be <strong>very specific</strong> about
          the problem. David Burns likes to say that all problems are "fractal":
          if you look at just one moment in time, in great detail, you'll find
          that it actually contains an encapsulated version of the entire larger
          problem. The goal in this step is to find that one moment.
        </p>
        <p>
          You might find it helpful to go about your day with a piece of paper
          handy, so you can write down when something triggers strong emotions.
          Just write down enough for you to remember what was happening at the
          time; then you can come back to this page and think about it in more
          detail later.
        </p>
        <p>
          It helps if the moment was an external trigger; for example, if a
          friend or family member said something that upset you, or if some
          inanimate object got you frustrated-- anything outside yourself that
          seemed to cause strong feelings that bothered you. But if you can't
          find an external trigger, the moment could also be "I started thinking
          about X and then I got really sad." But try to make it one specific
          moment in time. You should be able to identify the day and time it
          happened.
        </p>
        <p>
          Once you've identified the moment we'll be working with, write down
          enough information for you to remember it here. For example, "The time
          I was talking to Alice and she said she hates dogs, and I was really
          upset."
        </p>
        <div id="entry">
          <textarea
            id="text"
            value={this.state.instance}
            onChange={this.textChanged}
          ></textarea>
        </div>
      </div>
    );
  }
}

class Feelings extends React.Component {
  constructor(props) {
    super(props);
  }

  render() {
    return (
      <div>
        <div id="prompt">
          <p>You wrote:</p>
          <blockquote>{this.props.instance}</blockquote>
          <p>
            Select all the feelings that you felt during this moment, and rate
            out of 100 how strongly you felt that way.
          </p>
        </div>
        <div id="entry">
          <table className="feelings-table">
            <thead>
              <tr>
                <th>Feeling</th>
                <th>% (0-100)</th>
              </tr>
            </thead>
            <tbody>
              {feelingsList.map((feelingsCategory, feelingsCatIndex) => {
                let options = feelingsCategory.map((feeling) => {
                  return { key: feeling, description: feeling };
                });
                return (
                  <tr className="feelings-row" key={feelingsCatIndex}>
                    <td>
                      <CheckboxElement
                        localStoragePath={[
                          "feelings",
                          feelingsCatIndex.toString(),
                        ]}
                        options={options}
                        liClassName="feeling-li"
                        inputClassName="feeling"
                        labelClassName=""
                        nameClassName=""
                        descriptionClassName=""
                      />
                    </td>
                    <td>
                      <NumberInputElement
                        localStoragePath={[
                          "feelingsRatings",
                          feelingsCatIndex.toString(),
                        ]}
                        inputClassName="feelingRating"
                        min="0"
                        max="100"
                      />
                    </td>
                  </tr>
                );
              })}
            </tbody>
          </table>
        </div>
      </div>
    );
  }
}

class OneTextarea extends React.Component {
  constructor(props) {
    // props:
    // - localStoragePath
    // - className for textarea
    super(props);
    this.state = { entry: "" };
    this.handleChange = this.handleChange.bind(this);
    let fromStorage = getFromStorage(this.props.localStoragePath);
    if (!!fromStorage) {
      this.state.entry = fromStorage;
    }
  }

  componentDidUpdate() {
    putInStorage(this.props.localStoragePath, this.state.entry);
  }

  handleChange(event) {
    this.setState({ entry: event.target.value });
  }

  render() {
    return (
      <textarea
        className={this.props.className}
        onChange={this.handleChange}
        value={this.state.entry}
      ></textarea>
    );
  }
}

class SomeTextareas extends React.Component {
  constructor(props) {
    // props:
    // - localStoragePath
    // - minTextareas
    // - className for textareas
    super(props);
    this.state = { entries: [], extraTextareas: 0 };
    this.handleChange = this.handleChange.bind(this);
    let fromStorage = getFromStorage(this.props.localStoragePath);
    if (!!fromStorage) {
      this.state.entries = fromStorage;
    }
  }

  componentDidUpdate() {
    putInStorage(this.props.localStoragePath, this.state.entries);
  }

  handleChange(event) {
    let entries = [];
    document.querySelectorAll("." + this.props.className).forEach((element) => {
      if (element.value !== "") {
        entries.push(element.value);
      }
    });
    this.setState({ entries: entries });
  }

  render() {
    let numTextareas = Math.max(
      this.props.minTextareas,
      this.state.entries.length + 1
    );
    return (
      <div>
        {[...Array(numTextareas)].map((i, j) => {
          let entry = (() => {
            if (j < this.state.entries.length) {
              return this.state.entries[j];
            } else {
              return "";
            }
          })();
          return (
            <textarea
              key={j}
              className={this.props.className}
              onChange={this.handleChange}
              value={entry}
            ></textarea>
          );
        })}
      </div>
    );
  }
}

// TODO: Currently a bunch of other stuff keys off of indices for negative
// thoughts. Figure out how to handle it if a user edits/deletes a negative
// thought (or disallow that, maybe?)
class NegativeThoughts extends React.Component {
  constructor(props) {
    super(props);
  }

  render() {
    return (
      <div id="prompt">
        <p>
          Now, list some negative thoughts behind those emotions. These can be
          thoughts you had in the moment, or thoughts that seem to be 'powering'
          certain emotions when you think about them now.
        </p>
        <SomeTextareas
          localStoragePath={["negativeThoughts"]}
          className="negative-thought"
          minTextareas={5}
        />
      </div>
    );
  }
}

function randomFromList(list) {
  let index = Math.floor(Math.random() * list.length);
  return index; // Not list[index].
}

function randomFromDict(dict) {
  let keysList = Object.keys(dict);
  let keyIndex = Math.floor(Math.random() * keysList.length);
  return keysList[keyIndex]; // Returns an index into 'dict'.
}

class PositiveReframe extends React.Component {
  constructor(props) {
    // this.props.feelings, this.props.negativeThoughts
    super(props);

    this.handleChange = this.handleChange.bind(this);
    this.nextReframe = this.nextReframe.bind(this);
    this.previousReframes = this.previousReframes.bind(this);
    this.showCurrentItemPrompt = this.showCurrentItemPrompt.bind(this);
    this.showNullPrompt = this.showNullPrompt.bind(this);
    this.goBackToThought = this.goBackToThought.bind(this);
    this.goBackToFeeling = this.goBackToFeeling.bind(this);

    this.state = {
      positiveReframe: { feelings: {}, thoughts: {} },
    };
    if (!!JSONStorage.get("positiveReframe")) {
      this.state.positiveReframe = JSONStorage.get("positiveReframe");
    }
    this.generateNextItem = this.generateNextItem.bind(this);
    let [isFeeling, thoughtOrFeelingIndex] = this.generateNextItem();
    this.state.isFeeling = isFeeling;
    this.state.thoughtOrFeelingIndex = thoughtOrFeelingIndex;
  }

  componentDidUpdate() {
    JSONStorage.set("positiveReframe", this.state.positiveReframe);
  }

  // Generate a feeling or thought to reframe.
  generateNextItem() {
    // Figure out which feelings and thoughts we've already finished with.
    let unseenThoughts = [];
    for (const [thoughtIndex, thought] in this.props.negativeThoughts) {
      if (!this.state.positiveReframe.thoughts.hasOwnProperty(thoughtIndex)) {
        unseenThoughts.push(thoughtIndex);
      }
    }
    let unseenFeelings = [];
    for (const feelingIndex in this.props.feelings) {
      let categoryFeelings = this.props.feelings[feelingIndex];
      if (
        categoryFeelings.length > 0 &&
        !this.state.positiveReframe.feelings.hasOwnProperty(feelingIndex)
      ) {
        unseenFeelings.push(feelingIndex);
      }
    }
    // Pick from the remaining thoughts/feelings with uniform probability.
    let allItemsLength =
      Object.keys(unseenThoughts).length + Object.keys(unseenFeelings).length;
    if (allItemsLength === 0) {
      return [null, null];
    }
    let itemIndex = Math.floor(Math.random() * allItemsLength);
    if (itemIndex < unseenThoughts.length) {
      // Thought.
      let thoughtIndex = unseenThoughts[itemIndex];
      return [false, thoughtIndex];
    } else {
      // Feeling.
      let feelingIndex = unseenFeelings[itemIndex - unseenThoughts.length];
      return [true, feelingIndex];
    }
  }

  nextReframe(event) {
    let [isFeeling, thoughtOrFeelingIndex] = this.generateNextItem();
    this.setState({
      isFeeling: isFeeling,
      thoughtOrFeelingIndex: thoughtOrFeelingIndex,
    });
  }

  goBackToFeeling(event) {
    let feelingIndex = event.target.name;
    this.setState({ isFeeling: true, thoughtOrFeelingIndex: feelingIndex });
  }

  goBackToThought(event) {
    let thoughtIndex = event.target.name;
    this.setState({ isFeeling: false, thoughtOrFeelingIndex: thoughtIndex });
  }

  previousReframes() {
    if (
      Object.keys(this.state.positiveReframe.feelings).length === 0 &&
      Object.keys(this.state.positiveReframe.thoughts).length === 0
    ) {
      return null;
    }
    let previousFeelingReframes = Object.keys(
      this.state.positiveReframe.feelings
    ).map((feelingIndex) => {
      let feelingsReadable = this.props.feelings[feelingIndex].join(", ");
      let reframes = this.state.positiveReframe.feelings[feelingIndex];
      return (
        <div className="reframe-container" key={"feeling-" + feelingIndex}>
          <span className="feeling-name">{feelingsReadable}</span>
          <input
            className="feeling-button"
            type="button"
            name={feelingIndex}
            onClick={this.goBackToFeeling}
            value="edit"
          ></input>
          <ul>
            {reframes.map((reframe, i) => {
              return (
                <li
                  className="past-positive-reframe"
                  key={"feeling-" + feelingIndex + "-" + i}
                >
                  {reframe}
                </li>
              );
            })}
          </ul>
        </div>
      );
    });
    let previousThoughtReframes = Object.keys(
      this.state.positiveReframe.thoughts
    ).map((thoughtIndex) => {
      let thought = this.props.negativeThoughts[thoughtIndex];
      let reframes = this.state.positiveReframe.thoughts[thoughtIndex];
      return (
        <div className="reframe-container" key={"thought-" + thoughtIndex}>
          <span className="thought-name">{thought}</span>
          <input
            className="thought-button"
            type="button"
            name={thoughtIndex}
            onClick={this.goBackToThought}
            value="edit"
          ></input>
          <ul>
            {reframes.map((reframe, i) => {
              return (
                <li
                  className="past-positive-reframe"
                  key={"feeling-" + thoughtIndex + "-" + i}
                >
                  {reframe}
                </li>
              );
            })}
          </ul>
        </div>
      );
    });
    return (
      <div>
        <p>
          Benefits or good things you wrote about previous thoughts and
          emotions:
        </p>
        {previousFeelingReframes}
        {previousThoughtReframes}
      </div>
    );
  }

  handleChange(event) {
    if (event.target.classList.contains("positive-reframe-feeling")) {
      let updatedFeelings = {};
      for (var key in this.state.positiveReframe.feelings) {
        updatedFeelings[key] = this.state.positiveReframe.feelings[key];
      }
      // Just store all the reframes.
      let reframesForThisFeeling = [];
      document
        .querySelectorAll(".positive-reframe-feeling")
        .forEach((element) => {
          if (element.value !== "") {
            reframesForThisFeeling.push(element.value);
          }
        });
      let feelingIndex = event.target.name;
      updatedFeelings[feelingIndex] = reframesForThisFeeling;
      this.setState({
        positiveReframe: {
          feelings: updatedFeelings,
          thoughts: this.state.positiveReframe.thoughts,
        },
      });
    } else if (event.target.classList.contains("positive-reframe-thought")) {
      let updatedThoughts = {};
      for (var key in this.state.positiveReframe.thoughts) {
        updatedThoughts[key] = this.state.positiveReframe.thoughts[key];
      }
      // Just store all the reframes.
      let reframesForThisThought = [];
      document
        .querySelectorAll(".positive-reframe-thought")
        .forEach((element) => {
          if (element.value !== "") {
            reframesForThisThought.push(element.value);
          }
        });
      let thoughtIndex = event.target.name;
      updatedThoughts[thoughtIndex] = reframesForThisThought;
      this.setState({
        positiveReframe: {
          feelings: this.state.positiveReframe.feelings,
          thoughts: updatedThoughts,
        },
      });
    }
  }

  showNullPrompt() {
    return (
      <p>
        You've now done positive reframes of all your feelings and negative
        thoughts. Feel free to view and edit your work below.
      </p>
    );
  }

  showCurrentItemPrompt() {
    let selectedItemPrompt = (() => {
      if (this.state.isFeeling) {
        // Feeling.
        let feelings = this.props.feelings[this.state.thoughtOrFeelingIndex];
        return (
          <div>
            <p>You said you feel this way in this situation:</p>
            <blockquote>{feelings.join(", ")}</blockquote>
            <p>
              What are some benefits of this feeling in this situation, OR: ways
              that having this feeling shows something beautiful and awesome
              about you?, OR: ways that this feeling reflects something true and
              important about your values?
            </p>
          </div>
        );
      } else {
        // Thought.
        let thought =
          this.props.negativeThoughts[this.state.thoughtOrFeelingIndex];
        return (
          <div>
            <p>You said you have this thought:</p>
            <blockquote>{thought}</blockquote>
            <p>
              What are some benefits of this thought in this situation, OR: ways
              that having this thought shows something beautiful and awesome
              about you?, OR: ways that this thought reflects something true and
              important about your values?
            </p>
          </div>
        );
      }
    })();
    let currentReframe = (() => {
      if (this.state.isFeeling) {
        return (
          this.state.positiveReframe.feelings[
            this.state.thoughtOrFeelingIndex
          ] || []
        );
      } else {
        return (
          this.state.positiveReframe.thoughts[
            this.state.thoughtOrFeelingIndex
          ] || []
        );
      }
    })();
    let numTextareas = Math.max(5, currentReframe.length);
    let itemType = this.state.isFeeling ? "feeling" : "thought";
    // TODO: This explanation is really long... try to think of ways to break it down and make it easier to digest, break it into prompts, etc.
    // One suggestion was to use a checkbox for "has a concrete benefit" or "shows something good about me" or "shows something about my values" or "is connected to things I'm proud of about myself" etc.
    // Alternately: Use the guide in the Feeling Great book based on emotions->common positive reframes.
    return (
      <div id="prompt">
        <p>
          Now it's time to do a positive reframing of your negative emotions and
          thoughts. Although you may feel that these emotions and thoughts are
          unwanted, they likely have at least some positive sides or benefits,
          or they may come from parts of yourself that are beautiful and
          important to you.
        </p>
        <p>
          You may be thinking, "No way! I hate these emotions and I want them
          gone, that's why I'm doing therapy in the first place!" And that's
          totally fine. If it turns out, after doing this step, that you don't
          want them at all, then we'll work on getting rid of them. But before
          we do that, we're going to give those thoughts and feelings a chance
          to say their piece, and look for their merits. Just one last chance.
        </p>
        <p>
          Sometimes, even when a feeling is totally undesirable, there's
          something about it that shows something good <em>about you</em>. Here
          are some examples.
        </p>
        <ul>
          <li>
            Suppose you're feeling intensely guilty and ashamed about having
            annoyed someone else. Well, that shows that you care about other
            people and you don't want to hurt them! And as for concrete
            benefits, maybe feeling guilty helps show <em>other</em> people that
            you care; if you demonstrate your guilt to them, then maybe they'll
            be more forgiving.
          </li>
          <li>
            Or suppose you feel incredibly inadequate. That might be because you
            have high standards for yourself, and don't want to settle for less.
          </li>
          <li>
            Or suppose you're feeling despair. Maybe that shows that you're
            realistic, and can face the depressing truth. Or maybe that emotion
            is there to protect you: if you feel despairing, you're more likely
            to give up on situations that aren't going to work out anyway. The
            feeling is helping to protect you from disappointment.
          </li>
        </ul>
        <p>
          (These specific examples may not apply to you. Use at your discretion,
          based on what seems to fit your emotions and self best.)
        </p>
        <p>
          A couple more prompts to help you think of positive sides to your
          feelings and thoughts:
        </p>
        <ul className="reframe-prompts">
          <li>How does this feeling or thought protect me?</li>
          <li>How does this feeling or thought reflect positively on me?</li>
          <li>
            The reverse version: would I think poorly of someone if they NEVER
            had a feeling or thought like this one?
          </li>
          <li>Does this feeling make me want to give myself a hug?</li>
          <li>
            Does this feeling or thought reflect something true and important
            about my values?
          </li>
          <li>
            Is this feeling or thought related to a part of myself that I like?
          </li>
        </ul>
        <p>
          Try to think of at least a few positives for each negative emotion or
          thought. If you're able to do that, it will make the future CBT steps
          much easier. I like to think of this as being a little bit like the
          parable of Chesterton's Fence: if you come upon a fence and don't know
          why it's there, you'd do well to find out before going right ahead and
          knocking it down. Similarly, if you are having difficult feelings, it
          helps a lot to understand what's good about them and what they're
          telling you before getting rid of them.
        </p>
        <p>
          If you're having trouble with this exercise, I would recommend
          checking out the Feeling Great book; it has a lot more specific
          examples and guides to different emotions to help you identify what
          might be some positive sides to what you're feeling.
        </p>
        <p>With respect to the situation you mentioned in the first step:</p>
        <blockquote>{this.props.instance}</blockquote>
        {selectedItemPrompt}
        {[...Array(numTextareas)].map((unused, i) => {
          let reframe = (() => {
            if (i < currentReframe.length) {
              return currentReframe[i];
            } else {
              return "";
            }
          })();
          let className = (() => {
            if (this.state.isFeeling) {
              return "positive-reframe positive-reframe-feeling";
            } else {
              return "positive-reframe positive-reframe-thought";
            }
          })();
          return (
            <textarea
              key={i}
              className={className}
              onChange={this.handleChange}
              name={this.state.thoughtOrFeelingIndex}
              value={reframe}
            ></textarea>
          );
        })}
        <input
          type="button"
          className="new-positive-reframe-button active-ui-button"
          onClick={this.nextReframe}
          value={"done with reframing this " + itemType}
        ></input>
      </div>
    );
  }

  render() {
    let itemPrompt =
      this.state.isFeeling === null
        ? this.showNullPrompt()
        : this.showCurrentItemPrompt();
    return (
      <div>
        {itemPrompt}
        {this.previousReframes()}
      </div>
    );
  }
}

class NavButtons extends React.Component {
  constructor(props) {
    // this.props.currentStepSeen, this.props.lastStepSeen
    // this.props.goToStage is a list of functions.
    super(props);
  }

  render() {
    // TODO: Only show the next button if we have enough data to continue to the next step.
    return (
      <div>
        {[...Array(this.props.lastStepSeen + 1)].map((unused, i) => {
          let className =
            i === this.props.currentStepSeen
              ? "pressed-navbutton"
              : "navbutton";
          return (
            <input
              type="button"
              className={className}
              key={i}
              id={stages[i].shortname}
              value={stages[i].name}
              onClick={this.props.goToStage[i]}
            ></input>
          );
        })}
        <input
          type="button"
          key={this.props.lastStepSeen + 1}
          className="next-navbutton"
          id="next"
          value="next >"
          onClick={this.props.goToStage[this.props.currentStepSeen + 1]}
        ></input>
      </div>
    );
  }
}

class Goals extends React.Component {
  constructor(props) {
    // this.props.instance, this.props.feelings, this.props.feelingsRatings
    super(props);
  }

  render() {
    return (
      <div>
        <div id="prompt">
          <p>
            Now that you've looked at the positive side of your thoughts and
            feelings, it's time to think about whether you might want to change
            them, all things considered. After considering their positive sides,
            you may not want to get rid of them after all. Maybe they are
            actually beneficial to you, or highly meaningful. Alternately, you
            might think that the negatives outweigh the positives, and so you do
            want to reduce or eliminate the feeling. It's up to you. In this
            step, you'll select your goal for each category of feelings.
          </p>
          <p>You wrote:</p>
          <blockquote>{this.props.instance}</blockquote>
          <p>
            Previously, you rated how much you felt each of the following in
            this situation. Now, select how much you <em>ideally want</em> to
            have each feeling in the same situation. For example, if you're
            feeling 20% sad and you think that's about the right amount, you
            would put "20" in the "Goal" column for that feeling. If you want to
            remove all of your sadness, you would put "0". If you actually want
            to be be even sadder, you might put "40". Whatever you think is most
            appropriate and feels right to you.
          </p>
        </div>
        <div id="entry">
          <table className="feelings-table">
            <thead>
              <tr>
                <th>Feeling</th>
                <th>Original % (0-100)</th>
                <th>Goal % (0-100)</th>
              </tr>
            </thead>
            <tbody>
              {feelingsList.map((feelingsCategory, feelingsCatIndex) => {
                return (
                  <tr className="feelings-row" key={feelingsCatIndex}>
                    <td>
                      {feelingsCategory.map((feeling) => {
                        let checked =
                          this.props.feelings.hasOwnProperty(
                            feelingsCatIndex
                          ) &&
                          this.props.feelings[feelingsCatIndex].includes(
                            feeling
                          );
                        return (
                          <span key={feeling}>
                            <input
                              className="feeling read-only-feeling"
                              type="checkbox"
                              id={feeling}
                              name={feelingsCatIndex}
                              checked={checked}
                              readOnly
                            ></input>
                            <label htmlFor={feeling}>{feeling}</label>
                          </span>
                        );
                      })}
                    </td>
                    <td>
                      <input
                        className="feelingRating"
                        type="number"
                        min="0"
                        max="100"
                        name={feelingsCatIndex}
                        value={this.props.feelingsRatings[feelingsCatIndex]}
                        readOnly
                      ></input>
                    </td>
                    <td>
                      <NumberInputElement
                        localStoragePath={[
                          "feelingsRatingsGoal",
                          feelingsCatIndex.toString(),
                        ]}
                        inputClassName="feelingRating"
                        min="0"
                        max="100"
                      />
                    </td>
                  </tr>
                );
              })}
            </tbody>
          </table>
        </div>
      </div>
    );
  }
}

// For the Methods phase, I think we want to have the user select a single
// negative thought to work on. First rate their level of belief in the
// negative thought. Then we can try identifying distortions and see if that
// suggests any methods. For each suggested method, prompt them with the
// method, then have them try to write down how the method applies in their situation.
//
// After doing some number of methods (2-3?), or maybe after each one, have
// them re-rate their level of belief in the negative thought.
//
// After it gets down very low (below 10%?), and after they have a new
// method-based thought that they believe 100%, we move on to knocking down
// other negative thoughts.
// OR: if we run out of methods, let them know, and suggest we try something else:
// either 1) work on a different thought, 2) accept it?, 3) go to therapy... whatever.
// Basically a "seems like this didn't work for you, sorry, hope it helped at all?"
//
// After that comes... relapse prevention training? I'll have to reread about that.
// Make a list of the methods that worked best for their use later, along
// with whatever new thoughts they generated using each method.
//
// There should also be a "free space" method for "come up with a positive
// thought to replace the negative thought" without any actual helpful
// prompting, in case they want to do whatever framing they like.

// ---------------------------------------------
// This is the first methods component:
// 1) thought selection + rate level of belief in thought + distortion identification
class SelectThoughtForMethods extends React.Component {
  constructor(props) {
    super(props);
    this.state = {
      showDistortions: false,
    };
    if (!!localStorage["showDistortions"]) {
      this.state.showDistortions = localStorage["showDistortions"];
    }
    this.toggleShowDistortions = this.toggleShowDistortions.bind(this);
  }

  componentDidUpdate() {
    localStorage["showDistortions"] = this.state.showDistortions;
  }

  toggleShowDistortions() {
    this.setState({ showDistortions: !!!this.state.showDistortions });
  }

  render() {
    if (!!!this.state.showDistortions) {
      let negativeThoughtsJiggered = this.props.negativeThoughts.map(
        (thought, thoughtIndex) => {
          return { key: thoughtIndex, description: thought };
        }
      );
      return (
        <div>
          <div id="prompt">
            <p>
              The next step after goal-setting is to use the CBT methods to
              knock down the negative thoughts and achieve your feeling-level
              goals.
            </p>
            <p>
              <b>IMPORTANT NOTE:</b> We are <b>NOT</b> assuming that all of your
              negative thoughts are wrong. They may be partly or entirely true,
              or helpful for you to think. You may have found a strong positive
              side to some of the thoughts during the Positive Reframe step.
            </p>
            <p>
              BUT: you have set your own feeling goals, and since you are still
              here, you probably want to change at least some of your feelings
              related to this situation. The idea behind CBT is that in order to
              change your feelings, you have to change your thoughts.
            </p>
            <p>
              So for this step, please focus on the thoughts that you most WANT
              to change, because they are unhelpful or difficult for you to cope
              with. Alternately, if you feel a thought is simply impossible for
              you to refute, because it is correct, you may want to try the
              Acceptance Technique when you get to the Methods step.
            </p>
            <p>With that out of the way:</p>
            <p>
              Let's select a negative thought to work on first (we can look at
              the others later, just pick one to start off with).
            </p>
          </div>
          <div id="entry">
            <RadioSelectElement
              options={negativeThoughtsJiggered}
              localStoragePath={["selectedThought"]}
              liClassName="select-thought-group"
              inputClassName="select-thought"
              labelClassName=""
              descriptionClassName=""
              nameClassName=""
            />
            <input
              type="button"
              className="select-thought-button active-ui-button"
              value="continue >"
              onClick={this.toggleShowDistortions}
            ></input>
          </div>
        </div>
      );
    }
    let thoughtBeliefLevel =
      !!this.state.thoughtBeliefLevelInitial &&
      !!getFromStorage(["selectedThought"]) &&
      !!this.state.thoughtBeliefLevelInitial[
        getFromStorage(["selectedThought"])
      ]
        ? this.state.thoughtBeliefLevelInitial[
            getFromStorage(["selectedThought"])
          ]
        : "";
    let distortionsMunged = distortions.map((distortion) => {
      return {
        key: distortion.shortname,
        name: distortion.name,
        description: distortion.description,
      };
    });
    let distortionsPicker = (
      <div>
        <p>
          Let's see if we can identify any cognitive distortions that might be
          present in this thought. This step is optional, but it may help
          identify which methods will be most useful to deal with this thought.
        </p>
        <p>Which of the following do you think might apply to this thought?</p>
        <CheckboxElement
          localStoragePath={[
            "completedDistortions",
            getFromStorage(["selectedThought"]),
          ]}
          options={distortionsMunged}
          liClassName="distortion"
          inputClassName="distortion-checkbox"
          labelClassName="distortion-label"
          nameClassName="distortion-name"
          descriptionClassName="distortion-description"
        />
      </div>
    );
    let maybeDistortions = this.state.showDistortions ? distortionsPicker : "";
    let maybeShowDistortionsButton = this.state.showDistortions ? (
      ""
    ) : (
      <input
        type="button"
        className="select-thought-button active-ui-button"
        value="next >"
        onClick={this.toggleShowDistortions}
      ></input>
    );
    return (
      <div>
        <div id="prompt">
          <input
            type="button"
            className="select-thought-button active-ui-button"
            value="< select another thought"
            onClick={this.toggleShowDistortions}
          ></input>
          <p>You selected the thought:</p>
          <blockquote>
            {this.props.negativeThoughts[getFromStorage(["selectedThought"])]}
          </blockquote>
          <p>
            How much would you say you actually believe this thought, on a scale
            from 0 to 100?
          </p>
        </div>
        <div id="entry">
          <NumberInputElement
            inputClassName="thought-belief-rating"
            min="0"
            max="100"
            localStoragePath={[
              "thoughtBeliefLevelInitial",
              getFromStorage(["selectedThought"]),
            ]}
          />
          {maybeShowDistortionsButton}
          {maybeDistortions}
        </div>
      </div>
    );
  }
}

// TODO: Make this return only a recommended subset of all techniques.
function getSuggestedMethods() {
  return inAppTechniques;
}

function getMethod(shortname) {
  for (let i = 0; i < inAppTechniques.length; ++i) {
    if (inAppTechniques[i].shortname === shortname) {
      return inAppTechniques[i];
    }
  }
  return null;
}

// From https://stackoverflow.com/a/32922084
function deepEqual(x, y) {
  const ok = Object.keys,
    tx = typeof x,
    ty = typeof y;
  return x && y && tx === "object" && tx === ty
    ? ok(x).length === ok(y).length &&
        ok(x).every((key) => deepEqual(x[key], y[key]))
    : x === y;
}

function testAssert(a, b, string) {
  if (!deepEqual(a, b)) {
    console.error(string, "\nTEST FAILED: ", a, " !=== ", b);
    return false;
  }
  return true;
}

function testPutInStorage() {
  // First test: nothing exists.
  JSONStorage.set("1", null);
  putInStorage(["1", "2", "3", "4"], "test");
  testAssert(
    JSONStorage.get("1"),
    { 2: { 3: { 4: "test" } } },
    "nothing exists"
  );

  // Second test: '1' exists.
  JSONStorage.set("1", {});
  testAssert(JSONStorage.get("1"), {}, "setup for 1 existing");
  putInStorage(["1", "2", "3", "4"], "test");
  testAssert(JSONStorage.get("1"), { 2: { 3: { 4: "test" } } }, "1 exists");

  // Third test: '1' and '2' exist.
  JSONStorage.set("1", { 2: {} });
  testAssert(JSONStorage.get("1"), { 2: {} }, "setup for 1 and 2 existing");
  putInStorage(["1", "2", "3", "4"], "test");
  testAssert(
    JSONStorage.get("1"),
    { 2: { 3: { 4: "test" } } },
    "1 and 2 exist"
  );

  // '1', '2', and '3' exist.
  JSONStorage.set("1", { 2: { 3: {} } });
  testAssert(
    JSONStorage.get("1"),
    { 2: { 3: {} } },
    "setup for 1 2 and 3 existing"
  );
  putInStorage(["1", "2", "3", "4"], "test");
  testAssert(
    JSONStorage.get("1"),
    { 2: { 3: { 4: "test" } } },
    "1, 2, and 3 exist"
  );

  // '1', '2', and '3' exist, but 3 is null.
  JSONStorage.set("1", { 2: { 3: null } });
  testAssert(
    JSONStorage.get("1"),
    { 2: { 3: null } },
    "setup for 3 being null"
  );
  putInStorage(["1", "2", "3", "4"], "test");
  testAssert(JSONStorage.get("1"), { 2: { 3: { 4: "test" } } }, "3 is null");

  // '1', '2', '3', and '4' exist.
  JSONStorage.set("1", { 2: { 3: { 4: {} } } });
  testAssert(
    JSONStorage.get("1"),
    { 2: { 3: { 4: {} } } },
    "setup for 1-4 existing"
  );
  putInStorage(["1", "2", "3", "4"], "test");
  testAssert(
    JSONStorage.get("1"),
    { 2: { 3: { 4: "test" } } },
    "1, 2, 3, 4 exist"
  );

  // '1', '2', '3', and '4' exist, but 4 is null.
  JSONStorage.set("1", { 2: { 3: { 4: null } } });
  testAssert(
    JSONStorage.get("1"),
    { 2: { 3: { 4: null } } },
    "setup for 4 being null"
  );
  putInStorage(["1", "2", "3", "4"], "test");
  testAssert(JSONStorage.get("1"), { 2: { 3: { 4: "test" } } }, "4 is null");
}

class NumberInputElement extends React.Component {
  constructor(props) {
    // props:
    // - localStoragePath: list of strings, at least 1 long.
    //   ex: ['feeling', '0'] => the selected feelings under '0' will be stored like
    //   JSONStorage.get('feeling') => {'0': ['sad', 'happy']}
    //   This takes full ownership of the '0' sub-array.
    // - inputClassName
    // - min, max
    // OPTIONAL: onChangeCallback
    super(props);
    this.state = {
      value: "",
    };
    let fromStorage = getFromStorage(this.props.localStoragePath);
    if (!!fromStorage) {
      this.state.value = fromStorage;
    }
    this.onChange = this.onChange.bind(this);
  }

  onChange(event) {
    this.setState({ value: event.target.value });
    if (this.props.onChangeCallback !== undefined) {
      this.props.onChangeCallback(event.target.value);
    }
  }

  componentDidUpdate() {
    putInStorage(this.props.localStoragePath, this.state.value);
  }

  render() {
    return (
      <input
        className={this.props.inputClassName}
        type="number"
        min={this.props.min}
        max={this.props.max}
        value={this.state.value}
        onChange={this.onChange}
      ></input>
    );
  }
}

class CheckboxElement extends React.Component {
  constructor(props) {
    // props:
    // - localStoragePath: list of strings, at least 1 long.
    //   ex: ['feeling', '0'] => the selected feelings under '0' will be stored like
    //   JSONStorage.get('feeling') => {'0': ['sad', 'happy']}
    //   This takes full ownership of the '0' sub-array.
    // - options: list of dicts: {key, name, description} (name is optional)
    // - CSS classes: liClassName, inputClassName, labelClassName,
    //   nameClassName, descriptionClassName
    super(props);
    let selectedFromStorage = getFromStorage(this.props.localStoragePath);
    if (!Array.isArray(selectedFromStorage)) {
      putInStorage(this.props.localStoragePath, []);
    }
    this.state = {
      selected: getFromStorage(this.props.localStoragePath),
    };
    this.toggleOption = this.toggleOption.bind(this);
  }

  toggleOption(event) {
    let selectedOption = event.target.value;
    let prevSelected = this.state.selected;
    // Add to the selected list.
    if (event.target.checked) {
      if (!prevSelected.includes(selectedOption)) {
        prevSelected.push(selectedOption);
      }
    } else if (prevSelected.includes(selectedOption)) {
      // Remove from the selected list.
      let index = prevSelected.indexOf(selectedOption);
      prevSelected.splice(index, 1);
    }
    this.setState({ selected: prevSelected });
  }

  componentDidUpdate() {
    putInStorage(this.props.localStoragePath, this.state.selected);
  }

  render() {
    return (
      <div>
        <ul>
          {this.props.options.map((option) => {
            let isSelected =
              !!this.state.selected &&
              this.state.selected.includes(option.key.toString());
            return (
              <li className={this.props.liClassName} key={option.key}>
                <input
                  className={this.props.inputClassName}
                  type="checkbox"
                  id={option.key}
                  value={option.key}
                  onChange={this.toggleOption}
                  checked={isSelected}
                ></input>
                <label
                  className={this.props.labelClassName}
                  htmlFor={option.key}
                >
                  <span className={this.props.nameClassName}>
                    {option.name}
                  </span>
                  <span className={this.props.descriptionClassName}>
                    {option.description}
                  </span>
                </label>
              </li>
            );
          })}
        </ul>
      </div>
    );
  }
}

class RadioSelectElement extends React.Component {
  constructor(props) {
    // props:
    // - localStoragePath: list of strings, at least 1 long.
    //   ex: ['feeling', 'selected'] => the selected feeling will be stored like
    //   JSONStorage.get('feeling') => {'selected': 'sad'}
    // - options: list of JSON dicts with the 'key', 'description', and
    //   optionally 'name' property.
    // - various CSS classes: liClassName, inputClassName, labelClassName,
    //   descriptionClassName, nameClassName
    // OPTIONAL: onChangeCallback (NOTE: not really used/implemented)
    // OPTIONAL: visibleOptions (list of keys for the visible options)
    super(props);
    let selectedFromStorage = getFromStorage(this.props.localStoragePath);
    if (!!!selectedFromStorage) {
      putInStorage(this.props.localStoragePath, null);
    }
    this.state = {
      selected: selectedFromStorage || null,
    };

    this.selectOption = this.selectOption.bind(this);
  }

  selectOption(event) {
    // NOTE: because it's a radio button, there is no unselect.
    // Consider whether I want to add unselect later.
    this.setState({ selected: event.target.value.toString() });
    if (this.props.onChangeCallback !== undefined) {
      this.props.onChangeCallback(event.target.value.toString());
    }
  }

  componentDidUpdate() {
    putInStorage(this.props.localStoragePath, this.state.selected);
  }

  render() {
    return (
      <div>
        <ul>
          {this.props.options.map((option) => {
            let isSelected =
              !!this.state.selected &&
              this.state.selected === option.key.toString();
            let optionName = !!option.name ? (
              <span className={this.props.nameClassName}>{option.name}</span>
            ) : (
              ""
            );
            let isDisplayNone =
              this.props.visibleOptions !== undefined &&
              !this.props.visibleOptions.includes(option.key);
            let liClassName = isDisplayNone
              ? this.props.liClassName + " displaynone"
              : this.props.liClassName;
            return (
              <li className={liClassName} key={option.key}>
                <input
                  className={this.props.inputClassName}
                  type="radio"
                  id={option.key}
                  value={option.key}
                  onChange={this.selectOption}
                  checked={isSelected}
                ></input>
                <label
                  className={this.props.labelClassName}
                  htmlFor={option.key}
                >
                  {optionName}
                  <span className={this.props.descriptionClassName}>
                    {option.description}
                  </span>
                </label>
              </li>
            );
          })}
        </ul>
      </div>
    );
  }
}

// Returns a list of method shortnames.
function getVisibleMethods(methods, page, methodsPerPage) {
  let visibleMethods = [];
  for (
    let i = page * methodsPerPage;
    i < methods.length && i < (page + 1) * methodsPerPage;
    ++i
  ) {
    visibleMethods.push(methods[i].shortname);
  }
  return visibleMethods;
}

// TODO: write a pure function to suggest possible methods based on the thought
// properties (distortions, etc.).
// TODO: add the ability to grab more methods to choose from, track what
// they've seen so far, etc.
class SelectMethod extends React.Component {
  constructor(props) {
    super(props);
    this.state = { methodsPage: 0 };
    // TODO: load methods page from local storage.
    this.switchToPage = this.switchToPage.bind(this);
  }

  switchToPage(event) {
    this.setState({ methodsPage: Number(event.target.name) });
  }

  render() {
    let methodsToSelectFrom = getSuggestedMethods();
    let methodsPerPage = 4;
    let visibleMethods = getVisibleMethods(
      methodsToSelectFrom,
      this.state.methodsPage,
      methodsPerPage
    );
    let rejiggeredMethods = methodsToSelectFrom.map((method) => {
      return {
        key: method.shortname,
        name: method.name,
        description: method.description,
      };
    });
    let paginationButtons = [];
    if (this.state.methodsPage > 0) {
      paginationButtons.push(
        <input
          className="method-more-button chill-ui-button"
          type="button"
          value="< prev methods"
          name={this.state.methodsPage - 1}
          onClick={this.switchToPage}
        ></input>
      );
    }
    let j = 0;
    for (let i = 0; i < rejiggeredMethods.length; i += methodsPerPage) {
      let className =
        j === this.state.methodsPage
          ? "method-more-button pressed-chill-ui-button"
          : "method-more-button chill-ui-button";
      paginationButtons.push(
        <input
          className={className}
          type="button"
          value={(j + 1).toString()}
          name={j}
          onClick={this.switchToPage}
        ></input>
      );
      j += 1; // j is which page we're on
    }
    if (this.state.methodsPage * methodsPerPage < rejiggeredMethods.length) {
      paginationButtons.push(
        <input
          className="method-more-button chill-ui-button"
          type="button"
          value="more methods >"
          name={this.state.methodsPage + 1}
          onClick={this.switchToPage}
        ></input>
      );
    }
    return (
      <div>
        <p>You selected the thought:</p>
        <blockquote>
          {this.props.negativeThoughts[getFromStorage(["selectedThought"])]}
        </blockquote>
        <p>
          Now that you've selected a thought to work on, it's time to try out
          some CBT methods on that thought.
        </p>
        <p>
          Here are some methods that might be able to help you with this
          thought. Pick one to try out:
        </p>
        <RadioSelectElement
          options={rejiggeredMethods}
          visibleOptions={visibleMethods}
          localStoragePath={["selectedMethod"]}
          nameClassName="method-name"
          descriptionClassName="method-description"
          inputClassName="select-method"
          liClassName="select-method-group"
          labelClassName="select-method-label"
        />
        {paginationButtons}
      </div>
    );
  }
}

class UseMethod extends React.Component {
  constructor(props) {
    super(props);
  }

  render() {
    let selectedMethod = getMethod(getFromStorage(["selectedMethod"]));
    return (
      <div>
        <p>You selected the thought:</p>
        <blockquote>
          {this.props.negativeThoughts[getFromStorage(["selectedThought"])]}
        </blockquote>
        <p>And you selected this method to use with this thought:</p>
        <blockquote>
          <span className="method-name">{selectedMethod.name}</span>
          <p className="method-description">{selectedMethod.description}</p>
        </blockquote>
        <p>Try it here:</p>
        <OneTextarea
          className="method-textarea"
          localStoragePath={[
            "methods",
            getFromStorage(["selectedThought"]),
            getFromStorage(["selectedMethod"]),
            "result",
          ]}
        />
      </div>
    );
  }
}

class RateMethod extends React.Component {
  constructor(props) {
    super(props);
    this.updateNewThoughtWon = this.updateNewThoughtWon.bind(this);
    this.updateNewThoughtBelief = this.updateNewThoughtBelief.bind(this);

    this.state = { newThoughtWon: null, newThoughtBeliefLevel: null };
    let newThoughtBeliefLevel = getFromStorage([
      "methods",
      getFromStorage(["selectedThought"]),
      getFromStorage(["selectedMethod"]),
      "newThoughtBeliefLevel",
    ]);
    let newThoughtWon =
      getFromStorage([
        "methods",
        getFromStorage(["selectedThought"]),
        getFromStorage(["selectedMethod"]),
        "whoWon",
      ]) === "new";
  }

  // NOTE: this is sort of a dumb way to update it, using localStorage.
  // probably want to instead control it in THIS state and have the RadioSelect
  // do something different? ughhhhhhh.
  updateNewThoughtWon(value) {
    this.setState({ newThoughtWon: value });
  }

  updateNewThoughtBelief(value) {
    this.setState({ newThoughtBeliefLevel: value });
  }

  render() {
    let newThoughtBeliefPicker = (
      <div>
        <p>How much do you believe this NEW thought?</p>
        <NumberInputElement
          localStoragePath={[
            "methods",
            getFromStorage(["selectedThought"]),
            getFromStorage(["selectedMethod"]),
            "newThoughtBeliefLevel",
          ]}
          inputClassName="thought-belief-picker"
          min="0"
          max="100"
          onChangeCallback={this.updateNewThoughtBelief}
        />
      </div>
    );
    let oldThoughtNewBeliefPicker = (
      <div>
        <p>
          Now, after using the method, how much do you believe the OLD thought?
        </p>
        <NumberInputElement
          localStoragePath={[
            "methods",
            getFromStorage(["selectedThought"]),
            getFromStorage(["selectedMethod"]),
            "oldThoughtNewBeliefLevel",
          ]}
          inputClassName="thought-belief-picker"
          min="0"
          max="100"
        />
      </div>
    );
    // NOTE: getting this to display conditional on the new thought winning is
    // messed up and I don't have time to fix the bug rn. So I'll just display
    // it unconditionally for now.
    /*
    let maybeNewThoughtBeliefPicker = this.state.newThoughtWon
      ? newThoughtBeliefPicker
      : "";
    */
    return (
      <div>
        <p>You were working with the thought:</p>
        <blockquote>
          {this.props.negativeThoughts[getFromStorage(["selectedThought"])]}
        </blockquote>
        <p>
          And your response to this thought, using the{" "}
          <span className="method-name">
            {getMethod(getFromStorage(["selectedMethod"])).name}
          </span>{" "}
          method was:
        </p>
        <blockquote>
          {getFromStorage([
            "methods",
            getFromStorage(["selectedThought"]),
            getFromStorage(["selectedMethod"]),
            "result",
          ])}
          <input
            className="thought-button"
            type="button"
            onClick={this.setUseMethod}
            value="edit"
          ></input>
        </blockquote>
        <p>
          Who do you think won this round? The negative thought, or the new
          response to it?
        </p>
        <RadioSelectElement
          localStoragePath={[
            "methods",
            getFromStorage(["selectedThought"]),
            getFromStorage(["selectedMethod"]),
            "whoWon",
          ]}
          options={[
            { key: "negative", description: "The negative thought" },
            { key: "new", description: "The new thought" },
          ]}
          liClassName="select-who-won-group"
          inputClassName="select-who-won"
          labelClassName=""
          descriptionClassName=""
          nameClassName=""
          onChangeCallback={this.updateNewThoughtWon}
        />
        {newThoughtBeliefPicker}
        {oldThoughtNewBeliefPicker}
      </div>
    );
  }
}

class FinalScreen extends React.Component {
  constructor(props) {
    super(props);
    this.tryAgain = this.tryAgain.bind(this);
    this.differentMethod = this.differentMethod.bind(this);
    this.differentThought = this.differentThought.bind(this);
  }

  tryAgain() {
    this.props.goToStage(8); // 8 is UseMethod
  }

  differentMethod() {
    this.props.goToStage(7); // 7 is SelectMethod
  }

  differentThought() {
    this.props.goToStage(6); // 6 is SelectThought
  }

  render() {
    let goBackOptions = (
      <div>
        <input
          className="active-ui-button"
          type="button"
          value="Try this method again"
          onClick={this.tryAgain}
        ></input>
        <input
          className="active-ui-button"
          type="button"
          value="Try a different method"
          onClick={this.differentMethod}
        ></input>
        <input
          className="chill-ui-button"
          type="button"
          value="Go back and work on a different thought"
          onClick={this.differentThought}
        ></input>
      </div>
    );
    let flavorText = "";
    if (!this.props.newThoughtWon) {
      flavorText = `The negative thought won over the new thought. OK. That
        sounds like we should try something else. Maybe a new method would help?`;
    } else if (this.props.newThoughtBeliefLevel < 50) {
      flavorText = `Hmm. It seems like the method helped, but you don't believe
        it that much. Okay. That sounds like we should try again. Could you
        adjust your new thought to make it more compelling? Or you could try a
        different method.`;
    } else if (this.props.oldThoughtBeliefLevel > 50) {
      flavorText = `OK! It sounds like you came up with a good new thought that
        you believe, but you still believe the negative thought too. If you
        can, it's often helpful to find a new thought that totally refutes the
        old negative thought. Want to try again? Or you could move on to a
        different method, or a different thought.`;
    } else {
      flavorText = `Great! It sounds like the method helped you knock down that
        negative thought. Typically if you find a really good way to knock down
        one negative thought, the next ones will be easier. Would you like to
        go back and finish off the other thoughts?`;
    }
    return (
      <div id="prompt">
        <h2>What should we do now?</h2>
        <p>{flavorText}</p>
        {goBackOptions}
        <h2>Or if you're done...</h2>
        <p>
          This is the last screen, so feel free to go back and do more work at
          your own pace, or to call it done when you feel you've gotten what you
          needed. I hope this process is helpful for you.
        </p>
        <p>
          Don't forget to <b>take care of yourself</b>: working with negative
          and difficult feelings can be draining. You may want to get yourself a
          cup of tea, snuggle a pet, or do something else cozy and relaxing
          after using the tool.
        </p>
        <p>
          <b>
            If you had good success using the tool, may I recommend that you{" "}
            <a href="print.html">print your results</a>
          </b>{" "}
          and save them for later? This can often be helpful to refer back to if
          you find yourself grappling with the same or similar issues later on.
        </p>
        <p>
          Thanks for trying out this tool! I would really appreciate any
          feedback you have, because it is still early stages and I know there's
          lots of work to do on it still. Please reach out and let me know how
          it worked for you.
        </p>
        <p>The tool is not finished. In the future I plan to add:</p>
        <ul>
          <li>A way to re-rate your feelings when you're done</li>
          <li>More help and prompts for the positive reframe step</li>
          <li>More techniques in the "Methods" section</li>
          <li>More help selecting a good method to use on each thought</li>
          <li>
            Some help with techniques you can't do just on a website (for
            example, the "experimental technique," where you test out the
            implications of a negative thought to see if it really seems to be
            true).
          </li>
        </ul>
      </div>
    );
  }
}

class MainContainer extends React.Component {
  constructor(props) {
    super(props);
    this.stageFns = this.stageFns.bind(this);
    this.state = { lastStepSeen: 0, currentStepSeen: 0, showFileUpload: false };
    // Load lastStepSeen/currentStepSeen from localStorage.
    if (!!localStorage["lastStepSeen"]) {
      this.state.lastStepSeen = parseInt(localStorage["lastStepSeen"]);
    }
    if (!!localStorage["currentStepSeen"]) {
      this.state.currentStepSeen = parseInt(localStorage["currentStepSeen"]);
    }
    this.goToStage = this.goToStage.bind(this);
    this.toggleShowFileUpload = this.toggleShowFileUpload.bind(this);
    this.load = this.load.bind(this);
    this.clear = this.clear.bind(this);
  }

  toggleShowFileUpload() {
    this.setState({ showFileUpload: !!!this.state.showFileUpload });
  }

  load() {
    let files = document.getElementById("filething").files;
    if (files.length < 1) {
      alert("Please select a file to upload.");
      return;
    }
    if (
      !confirm(
        "Loading will overwrite your current progress. If you haven't saved your data, it will be lost. Continue with loading from file?"
      )
    ) {
      return;
    }
    let file = files[0];
    let reader = new FileReader();
    reader.onload = (e) => {
      let parsed = JSON.parse(e.target.result);
      console.log("file data", parsed);
      setLocalStorage(parsed);
      window.location.reload();
    };
    reader.readAsText(file);
  }

  clear() {
    if (
      !confirm(
        "This will clear all your data from the web app! If you haven't saved your data, it will be lost. Continue with clear?"
      )
    ) {
      return;
    }
    setLocalStorage({});
    this.setState({ lastStepSeen: 0 });
    this.goToStage(0);
  }

  goToStage(stage) {
    this.setState({ currentStepSeen: stage });
  }

  stageFns() {
    return [
      () => {
        return <Introduction />;
      },
      () => {
        return <Moment />;
      },
      () => {
        return <Feelings instance={localStorage["instance"]} />;
      },
      () => {
        return <NegativeThoughts />;
      },
      () => {
        // 4
        return (
          <PositiveReframe
            instance={localStorage["instance"]}
            feelings={JSONStorage.get("feelings")}
            negativeThoughts={JSONStorage.get("negativeThoughts")}
          />
        );
      },
      () => {
        // 5
        return (
          <Goals
            instance={localStorage["instance"]}
            feelings={JSONStorage.get("feelings")}
            feelingsRatings={JSONStorage.get("feelingsRatings")}
          />
        );
      },
      () => {
        // 6
        return (
          <SelectThoughtForMethods
            negativeThoughts={JSONStorage.get("negativeThoughts")}
          />
        );
      },
      () => {
        // 7
        return (
          <SelectMethod
            negativeThoughts={JSONStorage.get("negativeThoughts")}
          />
        );
      },
      () => {
        // 8
        return (
          <UseMethod negativeThoughts={JSONStorage.get("negativeThoughts")} />
        );
      },
      () => {
        // 9
        return (
          <RateMethod negativeThoughts={JSONStorage.get("negativeThoughts")} />
        );
      },
      () => {
        let newThoughtWon = getFromStorage([
          "methods",
          getFromStorage(["selectedThought"]),
          getFromStorage(["selectedMethod"]),
          "newThoughtWon",
        ]);
        let newThoughtBeliefLevel = getFromStorage([
          "methods",
          getFromStorage(["selectedThought"]),
          getFromStorage(["selectedMethod"]),
          "newThoughtBeliefLevel",
        ]);
        let oldThoughtNewBeliefLevel = getFromStorage([
          "methods",
          getFromStorage(["selectedThought"]),
          getFromStorage(["selectedMethod"]),
          "oldThoughtNewBeliefLevel",
        ]);
        return (
          <FinalScreen
            newThoughtWon={newThoughtWon}
            newThoughtBeliefLevel={newThoughtBeliefLevel}
            oldThoughtNewBeliefLevel={oldThoughtNewBeliefLevel}
            goToStage={this.goToStage}
          />
        );
      },
    ];
  }

  componentDidUpdate() {
    localStorage["currentStepSeen"] = this.state.currentStepSeen;
    localStorage["lastStepSeen"] = this.state.lastStepSeen;
  }

  render() {
    // Show whichever container is relevant.
    let goToStage = [...Array(this.stageFns().length)].map((unused, j) => {
      return () => {
        this.setState({
          currentStepSeen: j,
          lastStepSeen: Math.max(j, this.state.lastStepSeen),
        });
      };
    });
    let maybeFileUpload = this.state.showFileUpload ? (
      <div>
        <input type="file" accept="text/json" id="filething"></input>
        <input
          type="button"
          value="load from this file"
          onClick={this.load}
          className="active-ui-button"
        ></input>
      </div>
    ) : (
      ""
    );
    return (
      <div>
        <div className="top-bar">
          <h1 className="title">Feeling Great TEAM Therapy Helper</h1>
          <a
            href={`data:text/json;charset=utf-8,${encodeURIComponent(
              JSON.stringify(localStorage)
            )}`}
            download="feeling_great_data.json"
            className="save-load-button chill-ui-button"
          >
            save
          </a>
          <a
            className="save-load-button chill-ui-button"
            onClick={this.toggleShowFileUpload}
          >
            load
          </a>
          <a className="save-load-button chill-ui-button" onClick={this.clear}>
            clear
          </a>
          <a
            className="save-load-button chill-ui-button"
            href="print.html"
            target="_blank"
          >
            print results
          </a>
          {maybeFileUpload}
        </div>
        <hr></hr>
        {this.stageFns()[this.state.currentStepSeen]()}
        <hr></hr>
        <NavButtons
          currentStepSeen={this.state.currentStepSeen}
          lastStepSeen={this.state.lastStepSeen}
          goToStage={goToStage}
        />
      </div>
    );
  }
}

// Initialize React.
const domContainer = document.querySelector("#react_container");
const root = ReactDOM.createRoot(domContainer);
root.render(e(MainContainer));
